/*
 * reference_parser.cpp
 *
 *  Created on: Nov 2, 2010
 *      Author: philipp_
 */

#include "reference_parser.h"

#include <fstream>
#include <cstdlib>

#include "helper/helpers.h"

using std::ifstream;
using std::ios;

//read in reference
void getNextScaff(Reference & ref,Parameters parameters){

	ifstream myfile (ref.get_filename());

	if(ref.flag){//if overlapping peace store position form which to restart from
		//inc is just correct if the ref is too large (over two runs)!
		//normally it has to be set (just overlapping!

		//wenn ein groszes Stueck daher kommt
		if(ref.get_scaff_pos(ref.name.size()-1)==0){
			ref.set_scaff_pos((int)(ref.sequence[ref.sequence.size()-1].size()-1)-ref.get_overlap());
		}else{
			ref.inc_scaff_pos((int)(ref.sequence[ref.sequence.size()-1].size()-1)-ref.get_overlap());
		}

		ref.set_id((int)ref.name.size()); //set ID_old to the last
		ref.name.push_back(ref.name[ref.name.size()-1]);
	}else{
		ref.set_id((int)ref.name.size()); //set ID_old to the last
		ref.set_scaff_pos(0); // nothing to start from
	}
	for(vector<string>::iterator i=ref.sequence.begin();i!=ref.sequence.end();i++){
		(*i).clear();
	}
	ref.sequence.clear();

	if(ref.get_file_pos()!=0){ //set back to the last read position
		if(myfile.fail()){
			cout<<"The reference File seems to be deleted! "<<endl;
			program_close(parameters.GPU_id);

		}
		myfile.seekg(ref.get_file_pos());
		myfile.seekg(-1,ios::cur);
	}else{
		if(myfile.fail()){ // ref file does not exists
			cout<<"The reference file does not exist! "<<endl;
			program_close(parameters.GPU_id);

		}
	}


	string seq;
	char buffer= myfile.get();
	size_t nucs=0;
	while (myfile.good()) {
		if (buffer == '>') { //if new chromosome
			if (seq.size() > 0) {
				//there are several small chromosomes
				nucs += seq.size();
				ref.sequence.push_back(seq);
				//				ref.set_scaff_pos(0);
				seq.clear();

				if (nucs + 300 >= parameters.max_scaffold_size) { //brake if we have enough.
					ref.set_file_pos(myfile.tellg());
					myfile.close();
					ref.flag = false;
					return;
				}
			}

			//A new chromosome is read in:
			string name;
			buffer = myfile.get();
			while (myfile.good() && buffer != '\0' && buffer != ' ' && buffer != '\n') { //reading in the name
				name += buffer;
				buffer = myfile.get();
			}

			ref.name.push_back(name);//stores all the names
			//			name.clear();

			while (buffer != '\n' && buffer != '\0') { //run until the end of the line
				buffer = myfile.get();
			}

		} else if (buffer != ' ' && buffer != '\0' && buffer != '\n') {

			while (myfile.good() && buffer != '\0' && buffer != '\n') { // parse the sequence
				seq += toupper(buffer);//just in case (same letter as the read

				if ((seq.size() + nucs + ref.get_overlap()) == parameters.max_scaffold_size && seq.size() > 200) {
					ref.set_file_pos(myfile.tellg()); //store the pos that is gone read of in the next function call
				} else if ((int) seq.size() + nucs == parameters.max_scaffold_size && seq.size() > 200) {
					//enough was read in for the next rung
					ref.sequence.push_back(seq);
					seq.clear();
					ref.flag = true;
					myfile.close();
					return;
				}
				buffer = myfile.get();
			}
		}
		buffer = myfile.get();
	}


	//finished reading reference file.
	if (myfile.eof()) {
		ref.set_file_pos(myfile.tellg());
	}
	ref.flag = false;
	ref.sequence.push_back(seq);

	if (seq.size() == 0 && ref.get_file_pos() == 0) {
		cout << "Error " << ref.get_filename() << endl;
	}

	seq.clear();
	myfile.close();
}

